'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'finduserfrommail.vbs  find a user within the Active Directory
'based on command-line specified email address
Option Explicit
On Error Resume Next
Dim refWMI
Dim colEveryone
Dim refUser
Dim strQuery

'check cmd-line argument
If WScript.Arguments.Count <> 1 Then
	WScript.Echo "Usage: finduserfrommail.vbs <email address>"
	WScript.Quit
End If

'attempt to connect to WMI
set refWMI = GetObject("winMgmts:root\directory\LDAP")
If Err <> 0 Then
	WScript.Echo "Oh dear. Could not connect to LDAP namespace"
	WScript.Quit
End If

'build and execute query
strQuery = "SELECT * FROM DS_user WHERE DS_mail = '" & _
WScript.Arguments(0) & "'"
set colEveryone = refWMI.ExecQuery(strQuery)

'display users' common name and logon
'logon uses Properties_() to avoid weird DS Provider bug
For Each refUser in colEveryone
	WScript.Echo refUser.DS_cn & "  " & _
	refUser.Properties_("DS_sAMAccountName")
Next
Set colEveryone = Nothing
Set refWMI = Nothing
