'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'listprocowner.vbs - list the names and owners of all processes running
'on the local machine
Option Explicit
On Error Resume Next
Dim refWMI
Dim colProcesses
Dim refItem
Dim strUser
Dim strDomain
Dim strSID

'try to connect to STYX
set refWMI = GetObject("winMgmts:")
If Err <> 0 Then
	WScript.Echo "I could not connect to WMI"
	WScript.Quit
End If

'Get a list of all processes and iterate through each
'printing name and SID. Use return values from GetOwner()
'and GetOwnerSID() as error handling device

'retrieve a Win32_SID object, and output the details of that object
Set colProcesses = refWMI.ExecQuery("SELECT * FROM Win32_Process")
For Each refItem In colProcesses
	If refItem.GetOwnerSID(strSID) = 0 Then
		set refSID = refWMI.Get("Win32_SID.SID='" & strSID & "'")
		If Err = 0 Then
			WScript.Echo refItem.Name & " is owned by " & _
				"\\" & refSid.ReferencedDomainName & _
				"\" & refSid.AccountName & " (" & _
				refSid.SID & ")"
		Else
			WScript.Echo "could not find a Win32_SID"
		End If
	Else
		WScript.Echo "Could not retrieve user info for " & _
		refItem.Name
	End If
Next
Set refSID = Nothing

Set colProcesses = Nothing
Set refWMI = Nothing
