'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'ownerNoLFO.vbs - retrieve the name of c:\boot.ini's owner
'without using Win32_LogicalFileOwner
Option Explicit
Dim refSetting
Dim refSD
Dim refOwner
Set refSetting = GetObject( _
	"winMgmts:Win32_LogicalFileSecuritySetting='c:\boot.ini'")

If refSetting.GetSecurityDescriptor(refSD) = 0 Then
	'operation was successful
	Set refOwner = refSD.Owner
	WScript.Echo refSetting.Path & " is owned by " & refOwner.Name
	Set refOwner = Nothing
	Set refSD = Nothing
End If
Set refSetting = Nothing
