'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

/* services.js - list services and report whether
* or not they are running. JScript translation of
* the first VBScript script.
*/
var refWMI;
var colServices;
var refService;

//connect to WMI and retrieve a collection of
//WMI Services objects, wrapped in an Enumerator
refWMI = GetObject("winMgmts:");
colServices = new Enumerator(
	refWMI.InstancesOf("Win32_Service")
);

//enumerate objects and report whether each
//service is running
for (;!colServices.atEnd();colServices.moveNext()){
	refService = colServices.item();
	WScript.Echo(refService.Name + " is "
		+ (refService.Started ? "not ":"")
		+ "running"
	);
}
colServices = null;
refWMI = null;
