'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

#services.pl - list services and report whether
#or not they are running
use Win32::OLE;

#connect to WMI and retrieve a collection of
#WMI Services objects
my $refWMI = Win32::OLE->GetObject("winMgmts:");
my $colServices = $refWMI->InstancesOf("Win32_Service");

#loop through collection using Win32::OLE's in
#function and report whether each service is running
foreach $refService(in $colServices){
	print $refService->{Name}
		. " is "
		. ($refService->{Started} ? "not " : "")
		. "running\n";
}
undef $colServices;
undef $refWMI;