'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'trustees.vbs - output the names of all trustees with rights to boot.ini
Option Explicit
Dim refSetting
Dim refSD
Dim refItem
Set refSetting = _
	GetObject("winMgmts:Win32_LogicalFileSecuritySetting='c:\boot.ini'")
If refSetting.GetSecurityDescriptor(refSD) = 0 Then
	For Each refItem In refSD.DACL
		WScript.Echo refItem.Trustee.Name
	Next
	Set refSD = Nothing
End If
Set refSetting = Nothing