'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof



'basicfileinfo.vbs - show basic information about boot.ini
'force VBScript to complain about use of undeclared variables
Option explicit

'declare a variable to be used as an object reference
Dim refFile

'use GetObject() to set the object reference
Set refFile = GetObject("winMgmts:CIM_DataFile.Name='c:\boot.ini'")

'output the file's name and size
Wscript.echo "File name is: " & refFile.Name
Wscript.echo "File size is: " & refFile.FileSize & " bytes"

'use conditional execution to report on any set attributes
If refFile.Archive then WScript.echo "The archive bit is set"
If refFile.Hidden then WScript.echo "This file is hidden"
If refFile.System then WScript.echo "This is a system file"

'output date information
Wscript.echo "The file was created on: " & refFile.CreationDate
Wscript.echo "The file was last modified on: " & refFile.LastModified
Wscript.echo "The file was last accessed on: " & refFile.LastAccessed
Set refFile = Nothing