'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'compressrare.vbs - compress rarely used files
Option Explicit
Dim refWMIService
Dim colRarelyUsedFiles
Dim refItem
Dim strQuery
set refWMIService = GetObject("winMgmts:")

'build the query string and execute the query
strQuery = "SELECT * FROM CIM_DataFile WHERE LastAccessed < '" & _
	   GetWMIDate(DateAdd("m",-1,Now),"+000") & _
           "' AND Compressed = 'False'"
set colRarelyUsedFiles = refWMIService.ExecQuery(strQuery)

'Now loop through the collection and attempt compression
'Report success or failure with WScript.echo
For Each refItem in colRarelyUsedFiles
	If refItem.Compress = 0 then
		WScript.echo refItem.Name & "compressed successfully"
	Else WScript.echo "Compression of " & refItem.Name " failed"
	End If
Next

'release objects
set colRarelyUsedFiles = Nothing
set refWMIService = Nothing

'This function turns a VBDate into a WMI date
Function GetWMIDate(vd,strOffset)
	GetWMIDate = Year(vd) & AddZero(Month(vd)) & AddZero(Day(vd)) & _
	AddZero(Hour(vd)) & AddZero(Minute(vd)) & _
	AddZero(Second(vd)) & ".000000" & strOffset
End Function

'This function turns a one-digit number into a two-character string
'It is used by GetWMIDate
Function AddZero(pNum)
	If pNum <= 9 then
		AddZero = "0" & pNum
	Else AddZero = pNum
	End If
End Function
