'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'digitalID.vbs
Option Explicit
Dim refRegistry
Dim arrValueData
Dim strValueData
Dim strSKPath
Dim strValueName
Dim i

'define symbolic constant for HKLM
Const HKEY_LOCAL_MACHINE = &H80000002

'retrieve StdRegProv class
Set refRegistry = GetObject("winmgmts:root\default:StdRegProv")

'prepare parameters for GetBinaryValue()
strSKPath = "SOFTWARE\Microsoft\Windows NT\CurrentVersion"
strValueName = "DigitalProductID"
If refRegistry.GetBinaryValue( _
  HKEY_LOCAL_MACHINE, strSKPath , strValueName , arrValueData) = 0 Then
	'call was successful so loop through array
	'and create human-readable string with the VBScript Hex()
	'function, VBScript Right() function and string concatenation
	For i = LBound(arrValueData) to UBound (arrValueData)
		strValueData = strValueData & _
			Right("00" & Hex(arrValueData(i)),2) & "-"
	Next
	
	'remove trailing dash
	strValueData = Left(strValueData, Len(strValueData) - 1)
	'display value
	WScript.Echo "Digital Product ID: " & strValueData
Else
	'call to GetBinaryValue() failed
	WScript.Echo "Unable to find the appropriate value"
End If

Set refRegistry = Nothing
